(function($){

	$.fn.twincolselect = function(options){
		var self = this;
		
		var sorting = null;
		var inputName = null;
		var maskBegginning = null;
		var buttonSettings = null;
		var title = null;
		
		var settings = $.extend({
			listWidth:100,
			toolbarButtonCss : {"display":"block","cursor":"pointer","backgroundColor":"#4E90E6","borderRadius":"2px","color":"#fff","margin":"2px 3px","padding":"3px 4px"},
			inactiveButton : {"backgroundColor":"#ccc","pointerEvents":"none"}//,
			//sorting : options.sorting === undefined || options.sorting == null ? self.sorting : options.sorting
		},options);
		var $jquery = this;

		var $left = null;
		var $right = null;
		
		$leftUlDiv = null;
		$rightUlDiv = null;
		
		var datasourceLeft = [];
		var datasourceRight = [];
		
		var selectedLeft = new Array();
		var selectedRight = new Array();
		
		var multiSelect = false;
		
		var $hiddenFormData = null;

		var output={
		
			"loadList" : function(elems,left){
				var $panel = null;
				var $ul = null;
				
				if(self.find(".left ul").get(0) === undefined){
					self.find(".left").append($("<ul/>"));
				}
				
				if(self.find(".right ul").get(0) === undefined){
					self.find(".right").append($("<ul/>"));
				}
				
				if(left){
					$ul = self.find(".left ul");
				}
				else{
					$ul = self.find(".right ul");
				}

				var $li = null;
				$.each(elems, function(index, elem){
					$li = $("<li/>");
					$li.attr("id",elem.id);
					$li.html(elem.value);
					$ul.append($li);
				});

				output.setupUl();
				
				var $elems = $ul.find("li");
				output.initList($elems,left);
			},
			
			"initList" :function(elems,left){

				$.each(elems, function(ind,el) {
						var $li = $(el);
						
						var data = {"id":$li.attr("id"),"value":$li.html()};
						if(left){
							datasourceLeft.push(data);
						}
						else{
							output.addItem(datasourceRight,data);
							output.refreshFormData();
						}
						
						$li.css({"padding":"2px 6px","listStyleType":"none","textAlign":"left"});
						//$li.css("width","auto");
						//$li.css("cursor","default");
						
						$li.click(function(e){
							
							left = $(e.target).parent().parent().attr("class").indexOf("left") !== -1;
							var selected = $(e.target).attr("selected");
							
							var foundInSelection = false;
							
							if( ! multiSelect){
								var elements = null;
								if(left){
									selectedLeft = [];
									elements = $(self).find(".left li");
									
								}
								else{
									selectedRight = [];
									elements = $(self).find(".right li");
									
								}
								
								$.each(elements,function(index,el){
									if(el.id === e.target.id){
										foundInSelection = true;
									}
									output.deSelect($(el));
								});
								
								
							}
							
							if(left){
								var rightElements = $(self).find(".right li");
								selectedRight = [];
								$.each(rightElements,function(index,el){
									output.deSelect($(el));
								});
							}
							else{
								var leftElements = $(self).find(".left li");
								selectedLeft = [];
								$.each(leftElements,function(index,el){
									output.deSelect($(el));
								});
							}
							if(selected === undefined){
								output.select($(e.target));
								if(left){
									output.addItem(selectedLeft,$(e.target).get(0));
								}
								else{
									output.addItem(selectedRight,$(e.target).get(0));
								}
							}
							else if(selected !== undefined && selected === "selected"){
								
								
									output.deSelect($(e.target));
									if(left){
										output.removeItem(selectedLeft,$(e.target).get(0));
									}
									else{
										output.removeItem(selectedRight,$(e.target).get(0));
									}
								
								
							}
							
						});
					});
			},
			
			"removeItem": function(arr,element){
				var ret = new Array();
				for(var i=0;i<arr.length;i++){
					if(arr[i] !== undefined && arr[i].id == element.id){
						ret.push(arr[i]);
					}
				}
				return ret;
			},
			
			"remove" : function(arrSource,arrRemove){
				for(var j=0;j<arrSource.length;j++){
					for(var k=0;k<arrRemove.length;k++){
						if(arrSource[j] !== undefined && arrRemove[k] != undefined){
							if(arrSource[j].id === arrRemove[k].id){
								delete arrSource[j];
							}
						}
						
					}
				}
			},
			
			"addItem": function(arr,element){
				arr.push(element);
			},
			
			"select" : function(el){
				el.attr("selected","selected");
				el.css("backgroundColor", "#ff8700");
			},
			
			"deSelect" : function(el){
				el.css("backgroundColor", "#ffffff");
				el.removeAttr("selected");
			},
			
			"moveToRight" : function(){
				var $right = $(self).find(".right ul");

				for(var i=0;i<selectedLeft.length;i++){
					
					output.deSelect($(selectedLeft[i]));
					$right.append($(selectedLeft[i]));
					var data = {"id":$(selectedLeft[i]).attr("id"),"value":$(selectedLeft[i]).html()};
					var removed = output.removeItem(datasourceLeft,data);
					output.remove(datasourceLeft,removed);
					output.addItem(datasourceRight,data);

				}
				output.refreshFormData();
				selectedLeft = [];
			},
			
			"refreshFormData": function (){
				$("#" + $(self).attr("id") + " input[type='hidden']").remove();
				for(var s=0;s<datasourceRight.length;s++){
					if(datasourceRight[s] !== undefined){
						//$hiddenFormData.get(0)[s] = datasourceRight[s];
						$hiddenFormData = $("<input/>");
						$hiddenFormData.attr("type","hidden");
						$hiddenFormData.attr("name",settings.inputName + "[]");
						$hiddenFormData.attr("value",datasourceRight[s].id);
						$(self).append($hiddenFormData);
					}
				}
			},
			
			"moveAllToRight" : function(){
				var elements = $(self).find(".left li");
				var $right = $(self).find(".right ul");
				$.each(elements, function(index,el){
					output.deSelect($(el));
					$right.append($(el));
					var data = {"id":$(el).attr("id"),"value":$(el).html()};
					var removed = output.removeItem(datasourceLeft,data);
					output.remove(datasourceLeft,removed);
					output.addItem(datasourceRight,data);
					//datasourceRight.push(data);
				});
				output.refreshFormData();
				selectedLeft = [];
			},
			
			"moveToLeft" : function(){
				var $left = $(self).find(".left ul");
				for(var i=0;i<selectedRight.length;i++){
					output.deSelect($(selectedRight[i]));
					$left.append($(selectedRight[i]));
					var data = {"id":$(selectedRight[i]).attr("id"),"value":$(selectedRight[i]).html()};
					var removed = output.removeItem(datasourceRight,data);
					output.remove(datasourceRight,removed);
					output.addItem(datasourceLeft,data);

				}
				output.refreshFormData();
				selectedRight = [];
			},
			
			"moveAllToLeft" : function(){
				var elements = $(self).find(".right li");
				var $left = $(self).find(".left ul");
				$.each(elements, function(index,el){
					
					output.deSelect($(el));
					$left.append($(el));
					var data = {"id":$(el).attr("id"),"value":$(el).html()};
					var removed = output.removeItem(datasourceRight,data);
					output.remove(datasourceRight,removed);
					output.addItem(datasourceLeft,data);
				});
				output.refreshFormData();
				selectedRight = [];
			},
			
			"setupHeader" : function(el,left){
				var $holder = $("<div/>");
				$holder.css({"width":"100%"});
				//$holder.css("height","10px");
				
				el.append($holder);
				
				output.initTitle($holder,left);
				output.addSearchInput($holder,left);
				//output.setupButtons($holder);

			},
			
			"initToolbar": function(el){
				var $toolbarHolder = $("<div/>");
				$toolbarHolder.css({
				"float":"left",
				"width":"10%",
				"height":"100%",
				"marginTop":"50px",
				"display":"table-cell",
				"textAlign":"center"});

				var $addToRight = $("<a/>");
				$addToRight.html(">");
				
				$addToRight.click(function(e){
					output.moveToRight();
				});
				
				$addToRight.css(settings.toolbarButtonCss);

				if(settings.buttonSettings != undefined && settings.buttonSettings.addToRight !== undefined && settings.buttonSettings.addToRight == false){
					$addToRight.css(settings.inactiveButton);
				}

				var $addToLeft = $("<a/>");
				$addToLeft.html("<");
				
				$addToLeft.click(function(e){
					output.moveToLeft();
				});
				
				$addToLeft.css(settings.toolbarButtonCss);
				
				if(settings.buttonSettings != undefined && settings.buttonSettings.addToLeft !== undefined && settings.buttonSettings.addToLeft == false){
					$addToLeft.css(settings.inactiveButton);
				}
				
				var $addAllToRight = $("<a/>");
				$addAllToRight.html(">>");
				
				$addAllToRight.click(function(e){
					output.moveAllToRight();
				});
				
				$addAllToRight.css(settings.toolbarButtonCss);
				
				if(settings.buttonSettings != undefined && settings.buttonSettings.addAllToRight !== undefined && settings.buttonSettings.addAllToRight == false){
					$addAllToRight.css(settings.inactiveButton);
				}
				
				var $addAllToLeft = $("<a/>");
				$addAllToLeft.html("<<");
				
				$addAllToLeft.click(function(e){
					output.moveAllToLeft();
				});
				
				$addAllToLeft.css(settings.toolbarButtonCss);
				
				if(settings.buttonSettings != undefined && settings.buttonSettings.addAllToLeft !== undefined && settings.buttonSettings.addAllToLeft == false){
					$addAllToLeft.css(settings.inactiveButton);
				}
				
				$toolbarHolder.append($addToRight);
				$toolbarHolder.append($addAllToRight);
				$toolbarHolder.append($addToLeft);
				$toolbarHolder.append($addAllToLeft);
				
				$(el).append($toolbarHolder);
			},
			
			"addSearchInput" : function(el,left){
					var $c = $("<input/>");
					//$c.css("borderBottom","none");
					//$c.css("width",settings.width + "px");
					$c.css({"width":"99%","border":"2px solid #ccc"});
					$c.keyup(function(e){
					
						var text = $(e.target).val();
						//var left = $(e.target).parent().parent().attr("class").indexOf("left") !== -1;
						var elements = null;
						if(left){
							elements = $(self).find(".left li");
						}
						else{
							elements = $(self).find(".right li");
						}
						
						$.each(elements,function(index,element){
							if(text !== ""){
								var start = "";
								if(settings.maskBegginning !== undefined && settings.maskBegginning === true){
									start = "^";
								}
								var elementText = $(element).html();
								var reg = new RegExp(start + text,"gi");
								if(reg.test(elementText)){
									$(element).show();
								}
								else{
									$(element).hide();
								}
							}
							else{
								$(element).show();
							}

						});
						
					});
					el.append($c);
			},
			
			"initTitle" : function(holder,left){
				var $titleHolder = $("<div/>");
				$titleHolder.css({"textAlign":"center"});
				
				//<div class="float-left title center" style="width:378px"><div class="float-left" style="width:50%">title 1</div><div class="float-left" style="width:50%">title2</div></div>
				if(settings.titleLeft !== undefined && left){
					//var $titleLeft = $("<div/>");
					$titleHolder.html(settings.titleLeft);
					//$titleLeft.css({"float":"left","width":"50%", "textAlign":"center"});
					//$titleHolder.append($titleLeft);
				}
				
				if(settings.titleRight !== undefined && !left){
					//var $titleRight = $("<div/>");
					$titleHolder.html(settings.titleRight);
					//$titleRight.css({"float":"left","width":"50%", "textAlign":"center"});
					//$titleHolder.append($titleRight);
				}
				
				holder.append($titleHolder);
			},
			
			"setupButtons" : function(el){
					var $c = $("<a/>");
					$c.attr("href","javascript:void(0)");
					$c.html("add");
					$c.css("display","block");


			},
			
			"build" : function(){
				$jquery.each(function(index,element){
				
					//bal fő div
					$left = $("<div/>");
					$left.css({"float":"left","width":"45%","display":"table"});
					
					//bal ul-t tároló div megkeresése (adott)
					$leftUlDiv = $(element).find(".left");
					$leftUlDiv.css({"float":"left","width":"100%","height":"150px","border":"1px solid gray","overflow-y":"auto","border":"1px solid #ccc","borderTop":"none"});
					
					//jobb fő div
					$right = $("<div/>");
					$right.css({"float":"left","width":"45%","display":"table"});
					
					//jobb ul-t tároló div megkeresése (adott)
					$rightUlDiv = $(element).find(".right");
					$rightUlDiv.css({"float":"left","width":"100%","height":"150px","border":"1px solid gray","overflow-y":"auto","border":"1px solid #ccc","borderTop":"none"});
					
					var $leftUl = $(self).find(".left ul");
					var $rightUl = $(self).find(".right ul");
					
					output.setupUl();
					
					var leftElems = $leftUl.find("li");
					var rightElems = $rightUl.find("li");
					output.initList(leftElems,true);
					output.initList(rightElems,false);
					
					output.setupHeader($left,true);
					output.setupHeader($right,false);
					
					//output.initTitle();
					//$rightUlDiv.remove();		
					//leftUlDiv.remove();
					$left.append($leftUlDiv);
					$right.append($rightUlDiv);
					
					
					$(element).append($left);
					output.initToolbar(element);
					$(element).append($right);
					
					
				});
				
			},
			
			"listFunctions" : function(element){
				if(settings.sorting !== undefined){
					if(settings.sorting.left !== undefined && settings.sorting.left === true){
						$(element).find(".left ul").sortable();
					}
					if(settings.sorting.right !== undefined && settings.sorting.right === true){
						$(element).find(".right ul").sortable();
					}
				}
			},
			
			"setupUl" : function(){
			
				var $leftUl = $(self).find(".left ul");
				var $rightUl = $(self).find(".right ul");
				
				if($leftUl !== undefined && $leftUl !== null){
					$leftUl.css({"height":"140px","padding":"0","margin":"0","cursor":"default"});
				}
				if($rightUl !== undefined && $rightUl !== null){
					$rightUl.css({"height":"140px","padding":"0","margin":"0","cursor":"default"});
				}
				
			},

            'init':function(){
                $jquery.each(function(index,element){
                    var _this=this;
					output.build();

					$(element).css({"width":"auto","float":"left"});

					var hasUl = $(element).find("ul").get(0);
					
					if(hasUl !== undefined){
						
					}
					
					$(document.body).bind("keydown",function(e){
						var code = e.keyCode || e.which;
						if(code === 17){
							multiSelect = true;
						}
					});
					
					$(document.body).keyup(function(e){
						var code = e.keyCode || e.which;
						if(code === 17){
							multiSelect = false;
						}
					});

                    _this.$this=$(this);

                    _this.$this.on('click',function(e){
						
                    });
                });
            }
			
        };

        output.init();
        return output;
	};
	
})($);